/*************************************************************
 * This file was automatically generated on 2012-05-10.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing acceleration, magnetic field and angular velocity
	/// </summary>
	public class BrickIMU : Device 
	{
		private static byte TYPE_GET_ACCELERATION = 1;
		private static byte TYPE_GET_MAGNETIC_FIELD = 2;
		private static byte TYPE_GET_ANGULAR_VELOCITY = 3;
		private static byte TYPE_GET_ALL_DATA = 4;
		private static byte TYPE_GET_ORIENTATION = 5;
		private static byte TYPE_GET_QUATERNION = 6;
		private static byte TYPE_GET_IMU_TEMPERATURE = 7;
		private static byte TYPE_LEDS_ON = 8;
		private static byte TYPE_LEDS_OFF = 9;
		private static byte TYPE_ARE_LEDS_ON = 10;
		private static byte TYPE_SET_ACCELERATION_RANGE = 11;
		private static byte TYPE_GET_ACCELERATION_RANGE = 12;
		private static byte TYPE_SET_MAGNETOMETER_RANGE = 13;
		private static byte TYPE_GET_MAGNETOMETER_RANGE = 14;
		private static byte TYPE_SET_CONVERGENCE_SPEED = 15;
		private static byte TYPE_GET_CONVERGENCE_SPEED = 16;
		private static byte TYPE_SET_CALIBRATION = 17;
		private static byte TYPE_GET_CALIBRATION = 18;
		private static byte TYPE_SET_ACCELERATION_PERIOD = 19;
		private static byte TYPE_GET_ACCELERATION_PERIOD = 20;
		private static byte TYPE_SET_MAGNETIC_FIELD_PERIOD = 21;
		private static byte TYPE_GET_MAGNETIC_FIELD_PERIOD = 22;
		private static byte TYPE_SET_ANGULAR_VELOCITY_PERIOD = 23;
		private static byte TYPE_GET_ANGULAR_VELOCITY_PERIOD = 24;
		private static byte TYPE_SET_ALL_DATA_PERIOD = 25;
		private static byte TYPE_GET_ALL_DATA_PERIOD = 26;
		private static byte TYPE_SET_ORIENTATION_PERIOD = 27;
		private static byte TYPE_GET_ORIENTATION_PERIOD = 28;
		private static byte TYPE_SET_QUATERNION_PERIOD = 29;
		private static byte TYPE_GET_QUATERNION_PERIOD = 30;
		private static byte TYPE_ACCELERATION = 31;
		private static byte TYPE_MAGNETIC_FIELD = 32;
		private static byte TYPE_ANGULAR_VELOCITY = 33;
		private static byte TYPE_ALL_DATA = 34;
		private static byte TYPE_ORIENTATION = 35;
		private static byte TYPE_QUATERNION = 36;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetAccelerationPeriod"/>. The parameters are the acceleration
		///  for the x, y and z axis.
		/// </summary>
		public delegate void Acceleration(short x, short y, short z);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetMagneticFieldPeriod"/>. The parameters are the magnetic field
		///  for the x, y and z axis.
		/// </summary>
		public delegate void MagneticField(short x, short y, short z);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetAngularVelocityPeriod"/>. The parameters are the angular velocity
		///  for the x, y and z axis.
		/// </summary>
		public delegate void AngularVelocity(short x, short y, short z);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetAllDataPeriod"/>. The parameters are the acceleration,
		///  the magnetic field and the angular velocity for the x, y and z axis as
		///  well as the temperature of the IMU Brick.
		/// </summary>
		public delegate void AllData(short accX, short accY, short accZ, short magX, short magY, short magZ, short angX, short angY, short angZ, short temperature);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetOrientationPeriod"/>. The parameters are the orientation
		///  (roll, pitch and yaw) of the IMU Brick in Euler angles. See
		///  <see cref="Tinkerforge.BrickIMU.GetOrientation"/> for details.
		/// </summary>
		public delegate void Orientation(short roll, short pitch, short yaw);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickIMU.SetQuaternionPeriod"/>. The parameters are the orientation
		///  (x, y, z, w) of the IMU Brick in quaternions. See <see cref="Tinkerforge.BrickIMU.GetQuaternion"/>
		///  for details.
		/// </summary>
		public delegate void Quaternion(float x, float y, float z, float w);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickIMU(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_ACCELERATION] = new MessageCallback(CallbackAcceleration);
			messageCallbacks[TYPE_MAGNETIC_FIELD] = new MessageCallback(CallbackMagneticField);
			messageCallbacks[TYPE_ANGULAR_VELOCITY] = new MessageCallback(CallbackAngularVelocity);
			messageCallbacks[TYPE_ALL_DATA] = new MessageCallback(CallbackAllData);
			messageCallbacks[TYPE_ORIENTATION] = new MessageCallback(CallbackOrientation);
			messageCallbacks[TYPE_QUATERNION] = new MessageCallback(CallbackQuaternion);
		}

		/// <summary>
		///  Returns the calibrated acceleration from the accelerometer for the 
		///  x, y and z axis in mG (G/1000, 1G = 9.80605m/s²).
		///  
		///  If you want to get the acceleration periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.Acceleration"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetAccelerationPeriod"/>.
		/// </summary>
		public void GetAcceleration(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);
		}

		/// <summary>
		///  Returns the calibrated magnetic field from the magnetometer for the 
		///  x, y and z axis in mG (Milligauss or Nanotesla).
		///  
		///  If you want to get the magnetic field periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.MagneticField"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetMagneticFieldPeriod"/>.
		/// </summary>
		public void GetMagneticField(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETIC_FIELD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETIC_FIELD, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);
		}

		/// <summary>
		///  Returns the calibrated angular velocity from the gyroscope for the 
		///  x, y and z axis in °/17.5s (you have to divide by 17.5 to
		///  get the value in °/s).
		///  
		///  If you want to get the angular velocity periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.AngularVelocity"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetAngularVelocityPeriod"/>.
		/// </summary>
		public void GetAngularVelocity(out short x, out short y, out short z)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANGULAR_VELOCITY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANGULAR_VELOCITY, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
			z = LEConverter.ShortFrom(8, answer);
		}

		/// <summary>
		///  Returns the data from <see cref="Tinkerforge.BrickIMU.GetAcceleration"/>, <see cref="Tinkerforge.BrickIMU.GetMagneticField"/> 
		///  and <see cref="Tinkerforge.BrickIMU.GetAngularVelocity"/> as well as the temperature of the IMU Brick.
		///  
		///  The temperature is given in °C/100.
		///  
		///  If you want to get the data periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.AllData"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetAllDataPeriod"/>.
		/// </summary>
		public void GetAllData(out short accX, out short accY, out short accZ, out short magX, out short magY, out short magZ, out short angX, out short angY, out short angZ, out short temperature)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ALL_DATA, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ALL_DATA, out answer);

			accX = LEConverter.ShortFrom(4, answer);
			accY = LEConverter.ShortFrom(6, answer);
			accZ = LEConverter.ShortFrom(8, answer);
			magX = LEConverter.ShortFrom(10, answer);
			magY = LEConverter.ShortFrom(12, answer);
			magZ = LEConverter.ShortFrom(14, answer);
			angX = LEConverter.ShortFrom(16, answer);
			angY = LEConverter.ShortFrom(18, answer);
			angZ = LEConverter.ShortFrom(20, answer);
			temperature = LEConverter.ShortFrom(22, answer);
		}

		/// <summary>
		///  Returns the current orientation (roll, pitch, yaw) of the IMU Brick as Euler
		///  angles in one-hundredth degree. Note that Euler angles always experience a
		///  `gimbal lock &lt;http://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
		///  
		///  We recommend that you use quaternions instead.
		///  
		///  The order to sequence in which the orientation values should be applied is 
		///  roll, yaw, pitch. 
		///  
		///  If you want to get the orientation periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.Orientation"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetOrientationPeriod"/>.
		/// </summary>
		public void GetOrientation(out short roll, out short pitch, out short yaw)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ORIENTATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ORIENTATION, out answer);

			roll = LEConverter.ShortFrom(4, answer);
			pitch = LEConverter.ShortFrom(6, answer);
			yaw = LEConverter.ShortFrom(8, answer);
		}

		/// <summary>
		///  Returns the current orientation (x, y, z, w) of the IMU as 
		///  `quaternions &lt;http://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation&gt;`__.
		///  
		///  You can go from quaternions to Euler angles with the following formula::
		///  
		///   roll  = atan2(2*y*w - 2*x*z, 1 - 2*y*y - 2*z*z)
		///   pitch = atan2(2*x*w - 2*y*z, 1 - 2*x*x - 2*z*z)
		///   yaw   = asin(2*x*y + 2*z*w)
		///  
		///  This process is not reversible, because of the 
		///  `gimbal lock &lt;http://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
		///  
		///  Converting the quaternions to an OpenGL translation matrix is
		///  possible with the following formula::
		///  
		///   matrix = [[1 - 2*(y*y + z*z), 2*(x*y - w*z),     2*(x*z + w*y),     0],
		///             [2*(x*y + w*z),     1 - 2*(x*x + z*z), 2*(y*z - w*x),     0],
		///             [2*(x*z - w*y),     2*(y*z + w*x),     1 - 2*(x*x + y*y), 0],
		///             [0,                 0,                 0,                 1]]
		///  
		///  If you want to get the quaternions periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickIMU.Quaternion"/> and set the period with 
		///  <see cref="Tinkerforge.BrickIMU.SetQuaternionPeriod"/>.
		/// </summary>
		public void GetQuaternion(out float x, out float y, out float z, out float w)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_QUATERNION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_QUATERNION, out answer);

			x = LEConverter.FloatFrom(4, answer);
			y = LEConverter.FloatFrom(8, answer);
			z = LEConverter.FloatFrom(12, answer);
			w = LEConverter.FloatFrom(16, answer);
		}

		/// <summary>
		///  Returns the temperature of the IMU Brick. The temperature is given in 
		///  °C/100.
		/// </summary>
		public short GetIMUTemperature()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_IMU_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_IMU_TEMPERATURE, out answer);

			return LEConverter.ShortFrom(4, answer);
		}

		/// <summary>
		///  Turns the orientation and direction LEDs of the IMU Brick on.
		/// </summary>
		public void LedsOn()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_LEDS_ON, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Turns the orientation and direction LEDs of the IMU Brick off.
		/// </summary>
		public void LedsOff()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_LEDS_OFF, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns true if the orientation and direction LEDs of the IMU Brick
		///  are on, false otherwise.
		/// </summary>
		public bool AreLedsOn()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_ARE_LEDS_ON, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_ARE_LEDS_ON, out answer);

			return LEConverter.BoolFrom(4, answer);
		}

		/// <summary>
		///  Not implemented yet.
		/// </summary>
		public void SetAccelerationRange(byte range)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ACCELERATION_RANGE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(range, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Not implemented yet.
		/// </summary>
		public byte GetAccelerationRange()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION_RANGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION_RANGE, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		/// <summary>
		///  Not implemented yet.
		/// </summary>
		public void SetMagnetometerRange(byte range)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MAGNETOMETER_RANGE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(range, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Not implemented yet.
		/// </summary>
		public byte GetMagnetometerRange()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETOMETER_RANGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETOMETER_RANGE, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		/// <summary>
		///  Sets the convergence speed of the IMU Brick in °/s. The convergence speed 
		///  determines how the different sensor measurements are fused.
		///  
		///  If the orientation of the IMU Brick is off by 10° and the convergence speed is 
		///  set to 20°/s, it will take 0.5s until the orientation is corrected. However,
		///  if the correct orientation is reached and the convergence speed is too high,
		///  the orientation will fluctuate with the fluctuations of the accelerometer and
		///  the magnetometer.
		///  
		///  If you set the convergence speed to 0, practically only the gyroscope is used
		///  to calculate the orientation. This gives very smooth movements, but errors of the
		///  gyroscope will not be corrected. If you set the convergence speed to something
		///  above 500, practically only the magnetometer and the accelerometer are used to
		///  calculate the orientation. In this case the movements are abrupt and the values
		///  will fluctuate, but there won't be any errors that accumulate over time.
		///  
		///  In an application with high angular velocities, we recommend a high convergence
		///  speed, so the errors of the gyroscope can be corrected fast. In applications with
		///  only slow movements we recommend a low convergence speed. You can change the
		///  convergence speed on the fly. So it is possible (and recommended) to increase 
		///  the convergence speed before an abrupt movement and decrease it afterwards 
		///  again.
		///  
		///  You might want to play around with the convergence speed in the Brick Viewer to
		///  get a feeling for a good value for your application.
		///  
		///  The default value is 30.
		/// </summary>
		public void SetConvergenceSpeed(ushort speed)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CONVERGENCE_SPEED, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(speed, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the convergence speed as set by <see cref="Tinkerforge.BrickIMU.SetConvergenceSpeed"/>.
		/// </summary>
		public ushort GetConvergenceSpeed()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CONVERGENCE_SPEED, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CONVERGENCE_SPEED, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		/// <summary>
		///  There are several different types that can be calibrated:
		///  
		///  <code>
		///   :header: "Type", "Description", "Values"
		///   :widths: 10, 40, 100
		///   "0", "Accelerometer Gain", "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]" 
		///   "1", "Accelerometer Bias", "[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]"
		///   "2", "Magnetometer Gain", "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]" 
		///   "3", "Magnetometer Bias", "[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]"
		///   "4", "Gyroscope Gain", "[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]" 
		///   "5", "Gyroscope Bias", "[bias xl, bias yl, bias zl, temp l, bias xh, bias yh, bias zh, temp h, 0, 0]"
		///  </code>
		///  
		///  The calibration via gain and bias is done with the following formula::
		///  
		///   new_value = (bias + orig_value) * gain_mul / gain_div
		///  
		///  If you really want to write your own calibration software, please keep
		///  in mind that you first have to undo the old calibration (set bias to 0 and
		///  gain to 1/1) and that you have to average over several thousand values
		///  to obtain a usable result in the end.
		///  
		///  The gyroscope bias is highly dependent on the temperature, so you have to
		///  calibrate the bias two times with different temperatures. The values xl, yl, zl 
		///  and temp l are the bias for x, y, z and the corresponding temperature for a 
		///  low temperature. The values xh, yh, zh and temp h are the same for a high 
		///  temperatures. The temperature difference should be at least 5°C. If you have 
		///  a temperature where the IMU Brick is mostly used, you should use this 
		///  temperature for one of the sampling points.
		///  
		///  <note>
		///   We highly recommend that you use the Brick Viewer to calibrate your
		///   IMU Brick.
		///  </note>
		/// </summary>
		public void SetCalibration(byte typ, short[] data)
		{
			byte[] data_ = new byte[25];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)25, 2, data_);
			LEConverter.To(typ, 4, data_);
			LEConverter.To(data, 5, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the calibration for a given type as set by <see cref="Tinkerforge.BrickIMU.SetCalibration"/>.
		/// </summary>
		public short[] GetCalibration(byte typ)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(typ, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CALIBRATION, out answer);

			return LEConverter.ShortArrayFrom(4, answer, 10);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.Acceleration"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAccelerationPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ACCELERATION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetAccelerationPeriod"/>.
		/// </summary>
		public uint GetAccelerationPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.MagneticField"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetMagneticFieldPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MAGNETIC_FIELD_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetMagneticFieldPeriod"/>.
		/// </summary>
		public uint GetMagneticFieldPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAGNETIC_FIELD_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAGNETIC_FIELD_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.AngularVelocity"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetAngularVelocityPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ANGULAR_VELOCITY_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetAngularVelocityPeriod"/>.
		/// </summary>
		public uint GetAngularVelocityPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ANGULAR_VELOCITY_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ANGULAR_VELOCITY_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.AllData"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetAllDataPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ALL_DATA_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetAllDataPeriod"/>.
		/// </summary>
		public uint GetAllDataPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ALL_DATA_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ALL_DATA_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.Orientation"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetOrientationPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ORIENTATION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetOrientationPeriod"/>.
		/// </summary>
		public uint GetOrientationPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ORIENTATION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ORIENTATION_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickIMU.Quaternion"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetQuaternionPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_QUATERNION_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickIMU.SetQuaternionPeriod"/>.
		/// </summary>
		public uint GetQuaternionPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_QUATERNION_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_QUATERNION_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetIMUTemperature(out short temperature)
		{
			temperature = GetIMUTemperature();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void AreLedsOn(out bool leds)
		{
			leds = AreLedsOn();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAccelerationRange(out byte range)
		{
			range = GetAccelerationRange();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetMagnetometerRange(out byte range)
		{
			range = GetMagnetometerRange();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetConvergenceSpeed(out ushort speed)
		{
			speed = GetConvergenceSpeed();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCalibration(byte typ, out short[] data)
		{
			data = GetCalibration(typ);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAccelerationPeriod(out uint period)
		{
			period = GetAccelerationPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetMagneticFieldPeriod(out uint period)
		{
			period = GetMagneticFieldPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAngularVelocityPeriod(out uint period)
		{
			period = GetAngularVelocityPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAllDataPeriod(out uint period)
		{
			period = GetAllDataPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetOrientationPeriod(out uint period)
		{
			period = GetOrientationPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetQuaternionPeriod(out uint period)
		{
			period = GetQuaternionPeriod();
		}

		internal int CallbackAcceleration(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((Acceleration)callbacks[TYPE_ACCELERATION])(x, y, z);
			return 10;
		}

		internal int CallbackMagneticField(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((MagneticField)callbacks[TYPE_MAGNETIC_FIELD])(x, y, z);
			return 10;
		}

		internal int CallbackAngularVelocity(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);
			short z = LEConverter.ShortFrom(8, data_);

			((AngularVelocity)callbacks[TYPE_ANGULAR_VELOCITY])(x, y, z);
			return 10;
		}

		internal int CallbackAllData(byte[] data_)
		{
			short accX = LEConverter.ShortFrom(4, data_);
			short accY = LEConverter.ShortFrom(6, data_);
			short accZ = LEConverter.ShortFrom(8, data_);
			short magX = LEConverter.ShortFrom(10, data_);
			short magY = LEConverter.ShortFrom(12, data_);
			short magZ = LEConverter.ShortFrom(14, data_);
			short angX = LEConverter.ShortFrom(16, data_);
			short angY = LEConverter.ShortFrom(18, data_);
			short angZ = LEConverter.ShortFrom(20, data_);
			short temperature = LEConverter.ShortFrom(22, data_);

			((AllData)callbacks[TYPE_ALL_DATA])(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
			return 24;
		}

		internal int CallbackOrientation(byte[] data_)
		{
			short roll = LEConverter.ShortFrom(4, data_);
			short pitch = LEConverter.ShortFrom(6, data_);
			short yaw = LEConverter.ShortFrom(8, data_);

			((Orientation)callbacks[TYPE_ORIENTATION])(roll, pitch, yaw);
			return 10;
		}

		internal int CallbackQuaternion(byte[] data_)
		{
			float x = LEConverter.FloatFrom(4, data_);
			float y = LEConverter.FloatFrom(8, data_);
			float z = LEConverter.FloatFrom(12, data_);
			float w = LEConverter.FloatFrom(16, data_);

			((Quaternion)callbacks[TYPE_QUATERNION])(x, y, z, w);
			return 20;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Acceleration))
			{
				callbacks[TYPE_ACCELERATION] = d;
			}
			else if(d.GetType() == typeof(MagneticField))
			{
				callbacks[TYPE_MAGNETIC_FIELD] = d;
			}
			else if(d.GetType() == typeof(AngularVelocity))
			{
				callbacks[TYPE_ANGULAR_VELOCITY] = d;
			}
			else if(d.GetType() == typeof(AllData))
			{
				callbacks[TYPE_ALL_DATA] = d;
			}
			else if(d.GetType() == typeof(Orientation))
			{
				callbacks[TYPE_ORIENTATION] = d;
			}
			else if(d.GetType() == typeof(Quaternion))
			{
				callbacks[TYPE_QUATERNION] = d;
			}
		}
	}
}
